import { RangeSetTree, Comparator, TreeIterator } from "./range-set-tree";
/**
 * A red-black underlying tree for [[`RangeSet`]].
 */
export declare class BintreeRBRangeSetTree<T> implements RangeSetTree<T> {
    private readonly tree;
    constructor(comparator: Comparator<T>);
    get size(): number;
    insert(item: T): void;
    remove(item: T): void;
    clear(): void;
    lowerBound(item: T): TreeIterator<T>;
    upperBound(item: T): TreeIterator<T>;
    iterator(): TreeIterator<T>;
}
/**
 * A regular underlying binary search tree for [[`RangeSet`]].
 */
export declare class BintreeRangeSetTree<T> implements RangeSetTree<T> {
    private readonly tree;
    constructor(comparator: Comparator<T>);
    get size(): number;
    insert(item: T): void;
    remove(item: T): void;
    clear(): void;
    lowerBound(item: T): TreeIterator<T>;
    upperBound(item: T): TreeIterator<T>;
    iterator(): TreeIterator<T>;
}
